libftdi1: Ftdi::List Class Reference

libftdi1 1.4

Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ftdi::List Class Reference

Device list. More...

`#include <ftdi.hpp>`

## Classes
class | Private

## Public Types
typedef std::list< Context > | ListType
| List type storing "Context" objects. More...
typedef ListType::iterator | iterator
| Iterator type for the container. More...
typedef ListType::const_iterator | const_iterator
| Const iterator type for the container. More...
typedef ListType::reverse_iterator | reverse_iterator
| Reverse iterator type for the container. More...
typedef ListType::const_reverse_iterator | const_reverse_iterator
| Const reverse iterator type for the container. More...

## Public Member Functions
| List (struct ftdi_device_list *devlist=0)
| ~List ()
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
reverse_iterator | rbegin ()
reverse_iterator | rend ()
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend () const
ListType::size_type | size () const
bool | empty () const
void | clear ()
void | push_back (const Context &element)
void | push_front (const Context &element)
iterator | erase (iterator pos)
iterator | erase (iterator beg, iterator end)

## Static Public Member Functions
static List * | find_all (Context &context, int vendor, int product)

## Detailed Description

Device list.

Definition at line 175 of file ftdi.hpp.

## Member Typedef Documentation

## ◆ ListType

typedef std::list<Context> Ftdi::List::ListType

List type storing "Context" objects.

Definition at line 184 of file ftdi.hpp.

## ◆ iterator

typedef ListType::iterator Ftdi::List::iterator

Iterator type for the container.

Definition at line 186 of file ftdi.hpp.

## ◆ const_iterator

typedef ListType::const_iterator Ftdi::List::const_iterator

Const iterator type for the container.

Definition at line 188 of file ftdi.hpp.

## ◆ reverse_iterator

typedef ListType::reverse_iterator Ftdi::List::reverse_iterator

Reverse iterator type for the container.

Definition at line 190 of file ftdi.hpp.

## ◆ const_reverse_iterator

typedef ListType::const_reverse_iterator Ftdi::List::const_reverse_iterator

Const reverse iterator type for the container.

Definition at line 192 of file ftdi.hpp.

## Constructor & Destructor Documentation

## ◆ List()

Ftdi::List::List | ( | struct ftdi_device_list * | devlist = `0` | ) |

Definition at line 501 of file ftdi.cpp.

References ftdi_device_list::dev, Ftdi::Context::get_strings(), ftdi_device_list::next, and Ftdi::Context::set_usb_device().

Referenced by find_all().

## ◆ ~List()

Ftdi::List::~List | ( |  | ) |

Definition at line 517 of file ftdi.cpp.

## Member Function Documentation

## ◆ find_all()

List * Ftdi::List::find_all | ( | Context & | context,
|  | int | vendor,
|  | int | product
| ) |  |
| static

Definition at line 668 of file ftdi.cpp.

References Ftdi::Context::context(), ftdi_usb_find_all(), and List().

## ◆ begin() [1/2]

List::iterator Ftdi::List::begin | ( |  | ) |

Return begin iterator for accessing the contained list elements

Returns
  Iterator

Definition at line 525 of file ftdi.cpp.

## ◆ end() [1/2]

List::iterator Ftdi::List::end | ( |  | ) |

Return end iterator for accessing the contained list elements

Returns
  Iterator

Definition at line 534 of file ftdi.cpp.

Referenced by erase().

## ◆ begin() [2/2]

List::const_iterator Ftdi::List::begin | ( |  | ) | const

Return begin iterator for accessing the contained list elements

Returns
  Const iterator

Definition at line 543 of file ftdi.cpp.

## ◆ end() [2/2]

List::const_iterator Ftdi::List::end | ( |  | ) | const

Return end iterator for accessing the contained list elements

Returns
  Const iterator

Definition at line 552 of file ftdi.cpp.

## ◆ rbegin() [1/2]

List::reverse_iterator Ftdi::List::rbegin | ( |  | ) |

Return begin reverse iterator for accessing the contained list elements

Returns
  Reverse iterator

Definition at line 561 of file ftdi.cpp.

## ◆ rend() [1/2]

List::reverse_iterator Ftdi::List::rend | ( |  | ) |

Return end reverse iterator for accessing the contained list elements

Returns
  Reverse iterator

Definition at line 570 of file ftdi.cpp.

## ◆ rbegin() [2/2]

List::const_reverse_iterator Ftdi::List::rbegin | ( |  | ) | const

Return begin reverse iterator for accessing the contained list elements

Returns
  Const reverse iterator

Definition at line 579 of file ftdi.cpp.

## ◆ rend() [2/2]

List::const_reverse_iterator Ftdi::List::rend | ( |  | ) | const

Return end reverse iterator for accessing the contained list elements

Returns
  Const reverse iterator

Definition at line 588 of file ftdi.cpp.

## ◆ size()

List::ListType::size_type Ftdi::List::size | ( |  | ) | const

Get number of elements stored in the list

Returns
  Number of elements

Definition at line 598 of file ftdi.cpp.

## ◆ empty()

bool Ftdi::List::empty | ( |  | ) | const

Check if list is empty

Returns
  True if empty, false otherwise

Definition at line 607 of file ftdi.cpp.

## ◆ clear()

void Ftdi::List::clear | ( |  | ) |

Removes all elements. Invalidates all iterators. Do it in a non-throwing way and also make sure we really free the allocated memory.

Definition at line 617 of file ftdi.cpp.

References ftdi_list_free().

## ◆ push_back()

void Ftdi::List::push_back | ( | const Context & | element | ) |

Appends a copy of the element as the new last element.

Parameters

  element | Value to copy and append

Definition at line 633 of file ftdi.cpp.

## ◆ push_front()

void Ftdi::List::push_front | ( | const Context & | element | ) |

Adds a copy of the element as the new first element.

Parameters

  element | Value to copy and add

Definition at line 642 of file ftdi.cpp.

## ◆ erase() [1/2]

List::iterator Ftdi::List::erase | ( | iterator | pos | ) |

Erase one element pointed by iterator

Parameters

  pos | Element to erase

Returns
  Position of the following element (or end())

Definition at line 652 of file ftdi.cpp.

## ◆ erase() [2/2]

List::iterator Ftdi::List::erase | ( | iterator | beg,
|  | iterator | end
| ) |  |

Erase a range of elements

Parameters

  beg | Begin of range
  end | End of range

Returns
  Position of the element after the erased range (or end())

Definition at line 663 of file ftdi.cpp.

References end().

The documentation for this class was generated from the following files:

- ftdi.hpp
- ftdi.cpp